## ncbi-vdb 2.10.9%2Bdfsg

=== libs/hdf5/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(abspath ../..)
MODULE = libs/hdf5

INT_LIBS = \

EXT_LIBS = \
	libkdf5

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

OBJFILES = \
	$(KDF5_OBJ)

include $(TOP)/build/Makefile.env

ifdef HDF5_INCDIR
	INCDIRS += $(addprefix -I,$(HDF5_INCDIR))
endif

#-------------------------------------------------------------------------------
# outer targets
#
ifeq (1,$(HAVE_HDF5))

all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(EXT_LIBS): makedirs
	@ $(MAKE_CMD) $(LIBDIR)/$@

else

all std: $(ALL_LIBS)

$(INT_LIBS):
	@ echo "NOTE - internal library $(@F) cannot be built:"         \
	       "It requires 'libhdf5' and its development headers."

$(EXT_LIBS):
	@ echo "NOTE - library $(@F) cannot be built:"                  \
	       "It requires 'libhdf5' and its development headers."
endif

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS)) \
	$(addprefix $(LIBDIR)/,$(EXT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# hdf5
#
$(LIBDIR)/libkdf5: $(addprefix $(LIBDIR)/libkdf5.,$(LIBEXT))

KDF5_SRC = \
	hdf5dir \
	hdf5file \
	hdf5arrayfile

KDF5_OBJ = \
	$(addsuffix .$(LOBX),$(KDF5_SRC))

KDF5_LIB = \
	-lhdf5 \
	-lz \

ifdef HDF5_LIBDIR
	KDF5_LIB += $(addprefix -L,$(HDF5_LIBDIR))
endif

$(LIBDIR)/libkdf5.$(SHLX): $(KDF5_OBJ)
	$(LD) --dlib --vers $(SRCDIR)/../ncbi-vdb/libncbi-vdb.vers -o $@ $^ $(KDF5_LIB)

$(LIBDIR)/libkdf5.$(LIBX): $(KDF5_OBJ)
	$(LD) --slib --vers $(SRCDIR)/../ncbi-vdb/libncbi-vdb.vers -o $@ $^ $(KDF5_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/kxml/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/kxml

INT_LIBS = \
	libkxml \
	libkxfs

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
ifeq (1,$(HAVE_XML2))

ifneq (,$(XML2_INCDIR))
INCDIRS += $(addprefix -I,$(XML2_INCDIR))
endif

all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

else

all std: $(ALL_LIBS)

$(INT_LIBS):
	@ echo "NOTE - internal library $(@F) cannot be built:"         \
	       "It requires 'libxml2' and its development headers."

$(EXT_LIBS):
	@ echo "NOTE - library $(@F) cannot be built:"                  \
	       "It requires 'libxml2' and its development headers."
endif

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# tiny, lightweight interface to libxml
#
$(ILIBDIR)/libkxml: $(addprefix $(ILIBDIR)/libkxml.,$(ILIBEXT))

XML_SRC = \
	xml

XML_OBJ = \
	$(addsuffix .$(LOBX),$(XML_SRC))

XML_LIB = \

$(ILIBDIR)/libkxml.$(LIBX): $(XML_OBJ)
	$(LD) --slib -o $@ $^ $(XML_LIB)

#-------------------------------------------------------------------------------
# kxfs
#
$(ILIBDIR)/libkxfs: $(addprefix $(ILIBDIR)/libkxfs.,$(ILIBEXT))

KXFS_SRC = \
	xtoc \
	xtoc-parsexml

KXFS_OBJ = \
	$(addsuffix .$(LOBX),$(KXFS_SRC))

KXFS_LIB = \

$(ILIBDIR)/libkxfs.$(LIBX): $(KXFS_OBJ)
	$(LD) --slib -o $@ $^ $(KXFS_LIB)


#-------------------------------------------------------------------------------
# fuzz
#
ifeq (1,$(HAVE_XML2))
fuzz: std
	cp $(addsuffix .$(LIBX),$(addprefix $(ILIBDIR)/,$(INT_LIBS))) $(FLIBDIR)/
endif

=== libs/ngs-py/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/ngs-py

INT_LIBS = \
	libngs-py

EXT_LIBS = \

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

include $(TOP)/build/Makefile.env

INCDIRS += \
	-I$(SRCDIR)/../ngs

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# ngs-py
#
$(ILIBDIR)/libngs-py: $(addprefix $(ILIBDIR)/libngs-py.,$(LIBX))

NGS_PY_SRC = \
	py_Manager

NGS_PY_LIB = \

NGS_PY_OBJ = \
	$(addsuffix .$(LOBX),$(NGS_PY_SRC))


$(ILIBDIR)/libngs-py.$(LIBX): $(NGS_PY_OBJ)
	$(LD) --slib -o $@ $^


#-------------------------------------------------------------------------------
# fuzz
#
fuzz: std
	cp $(addsuffix .$(LIBX),$(addprefix $(ILIBDIR)/,$(INT_LIBS))) $(FLIBDIR)/

=== libs/vxf/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/vxf

INT_LIBS = \
	libvxf \
	libwvxf

OBJFILES = \
	$(VXF_OBJ) \
	$(WVXF_OBJ)

include $(TOP)/build/Makefile.env

RWORKDIR = $(BINDIR)

ALL_LIBS = \
	$(INT_LIBS)

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(TARGDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(TARGDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# vdb transform library
#
$(TARGDIR)/libvxf: $(addprefix $(ILIBDIR)/libvxf.,$(ILIBEXT))

VXF_SRC = \
	ceil \
	clip \
	cut \
	echo \
	exists \
	floor \
	paste \
	round \
	trunc \
	unzip \
	map \
	funzip \
	vec-sum \
	min \
	max \
	rldecode \
	pack \
	unpack \
	izip \
	iunzip \
	diff \
	sum \
	bit_or \
	trim \
	deriv \
	integral \
	integral_0 \
	delta \
	undelta \
	add-row-id \
	subtract-row-id \
	irzip \
	rand_4na_2na \
	outlier-encoder \
	outlier-decoder \
	bunzip \
	simple-sub-select \
	extract_token \
	strtonum \
	sprintf \
	wgs-tokenize-accession \
	lower-case-tech-reads

VXF_OBJ = \
	$(addsuffix .$(LOBX),$(VXF_SRC))

VXF_LIB = \
	-dvdb \
	-dklib \
	-dm \
	-dz \
	-dbz2

$(ILIBDIR)/libvxf.$(LIBX): $(VXF_OBJ)
	$(LD) --slib -o $@ $^ $(VXF_LIB)

#-------------------------------------------------------------------------------
# wvdb transform library
#

$(TARGDIR)/libwvxf: $(addprefix $(ILIBDIR)/libwvxf.,$(ILIBEXT))

WVXF_SRC = \
	$(VXF_SRC) \
	zip \
	bzip \
	fzip \
	rlencode \
	checksum

WVXF_OBJ = \
	$(addsuffix .$(LOBX),$(WVXF_SRC))

# temporary
WVXF_LIB = \
	-dwvdb \
	-dwkdb \
	-dklib \
	-dm \
	-dz \
	-dbz2

$(ILIBDIR)/libwvxf.$(LIBX): $(WVXF_OBJ)
	$(LD) --slib -o $@ $^ $(WVXF_LIB)

libwvxf.vers.h:
	@ true

.PHONY: $(TARGDIR)/libwvxf

#-------------------------------------------------------------------------------
# vdb entrez library
#
ifeq (win,$(OS))
$(TARGDIR)/libvxfentrez:
	@ true
else
$(TARGDIR)/libvxfentrez: $(addprefix $(ILIBDIR)/libvxfentrez.,$(ILIBEXT))
endif

VXF_ENTREZ_SRC = \
	entrez

VXF_ENTREZ_OBJ = \
	$(addsuffix .$(LOBX),$(VXF_ENTREZ_SRC))

VXF_ENTREZ_LIB = \
	-dvdb \
	-dkns \
	-dklib \
	-dm \
	-dz

$(ILIBDIR)/libvxfentrez.$(LIBX): $(VXF_ENTREZ_OBJ)
	$(LD) --slib -o $@ $^ $(VXF_ENTREZ_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)
#-------------------------------------------------------------------------------
# fuzz
#
fuzz: std
	cp $(addsuffix .$(LIBX),$(addprefix $(ILIBDIR)/,$(INT_LIBS))) $(FLIBDIR)/

=== test/ngs-c++/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/ngs-c++

TEST_TOOLS = \
    test-ngs_sra-c++ \
    test-ngs_sradb-c++ \
    test-ngs_csra1-c++ \
	test-ngs_csra1pileup-c++ \

SLOW_TEST_TOOLS = \
	test-slow_ngs_csra1pileup-c++ \

include $(TOP)/build/Makefile.env

ifeq (,$(NGS_LIBDIR))

$(TEST_TOOLS):
	@true

runtests slowtests:
	@ echo "NGS C++ tests are not run since NGS library does not appear to be installed"

else

# make sure runs are not cached in the user repository when running tests
ifeq ($(wildcard ../../../asm-trace),)
	ifeq (,$(VDB_CONFIG))
		VDB_CONFIG = $(shell pwd)/../only-remote-repository.kfg
	endif
endif


$(TEST_TOOLS) $(SLOW_TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS) $(SLOW_TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------
# common defs
#
INCDIRS += -I$(NGS_INCDIR)

TEST_NGS_CPP_LIB = \
	-sncbi-ngs-c++ \
	-sncbi-vdb \
	-skapp \
    -sktst \
    -L$(NGS_LIBDIR) \
	-sngs-c++ \

#-------------------------------------------------------------------------------
# test-ngs_sra-c++
#
TEST_NGS_SRA_CPP_SRC = \
	SRAtest \
	ngsfixture

TEST_NGS_SRA_CPP_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_SRA_CPP_SRC))

$(TEST_BINDIR)/test-ngs_sra-c++: $(TEST_NGS_SRA_CPP_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_CPP_LIB)

sra: test-ngs_sra-c++
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-ngs_sradb-c++
#
TEST_NGS_SRADB_CPP_SRC = \
	SRADBtest \
	ngsfixture

TEST_NGS_SRADB_CPP_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_SRADB_CPP_SRC))

$(TEST_BINDIR)/test-ngs_sradb-c++: $(TEST_NGS_SRADB_CPP_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_CPP_LIB)

sradb: test-ngs_sradb-c++
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-ngs_csra1-c++
#
TEST_NGS_CSRA1_CPP_SRC = \
	CSRA1test \
	ngsfixture

TEST_NGS_CSRA1_CPP_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_CSRA1_CPP_SRC))

$(TEST_BINDIR)/test-ngs_csra1-c++: $(TEST_NGS_CSRA1_CPP_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_CPP_LIB)

csra1: test-ngs_csra1-c++
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-ngs_csra1pileup-c++
#
TEST_NGS_CSRA1PILEUP_CPP_SRC = \
	CSRA1PileupTest \
	CSRA1PileupFixture \
	ngsfixture

TEST_NGS_CSRA1PILEUP_CPP_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_CSRA1PILEUP_CPP_SRC))

$(TEST_BINDIR)/test-ngs_csra1pileup-c++: $(TEST_NGS_CSRA1PILEUP_CPP_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_CPP_LIB)

pileup: test-ngs_csra1pileup-c++
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-slow_ngs_csra1pileup-c++
#
TEST_NGS_SLOW_CSRA1PILEUP_CPP_SRC = \
	CSRA1PileupTest_Slow \
	CSRA1PileupFixture \
	ngsfixture

TEST_NGS_SLOW_CSRA1PILEUP_CPP_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_SLOW_CSRA1PILEUP_CPP_SRC))

$(TEST_BINDIR)/test-slow_ngs_csra1pileup-c++: $(TEST_NGS_SLOW_CSRA1PILEUP_CPP_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_CPP_LIB)

slowpileup: test-slow_ngs_csra1pileup-c++
	$(TEST_BINDIR)/$^

endif

=== test/vdb/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/vdb

TEST_TOOLS = \
	test-vdb \
	test-wvdb \
	test-dependencies \
	test-sparse-col-rw \
	test-sparse-col-rd \
	test-blob-val \
	test-VDB-3060 \
	test-VDB-3061 \
	test-bytecode \
	test-view \
	test-tablecursor \
	test-wtablecursor \
	test-view-cursor \
	test-VDB-4156   \

#	test-VDB-3418

include $(TOP)/build/Makefile.env


# make sure runs are not cached in the user repository when running tests
ifeq ($(wildcard ../../../asm-trace),)
	ifeq (,$(VDB_CONFIG))
		VDB_CONFIG = $(shell pwd)/../only-remote-repository.kfg
	endif
endif


$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

runtests: setup

setup:
	@ mkdir -p db

.PHONY: $(TEST_TOOLS) setup

clean: stdclean

READ_LIBS = \
	-skapp \
	-sktst \
	-sncbi-vdb

WRITE_LIBS = \
	-skapp \
	-sktst \
	-sncbi-wvdb

#-------------------------------------------------------------------------------
# test-vdb
#
TEST_VDB_SRC = \
	test-vdb

TEST_VDB_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_VDB_SRC))

$(TEST_BINDIR)/test-vdb: $(TEST_VDB_OBJ)
	$(LP) --exe -o $@ $^ $(READ_LIBS)

vdb: test-vdb
	$(TEST_BINDIR)/test-vdb

valgrind_vdb: std
	valgrind --ncbi --show-reachable=no $(TEST_BINDIR)/test-vdb

#-------------------------------------------------------------------------------
# test-dependencies
#
TEST_DEPS_SRC = \
	test-dependencies

TEST_DEPS_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_DEPS_SRC))

$(TEST_BINDIR)/test-dependencies: $(TEST_DEPS_OBJ)
	$(LP) --exe -o $@ $^ $(READ_LIBS)

deps: test-dependencies
	$(TEST_BINDIR)/test-dependencies

valgrind_deps: std
	valgrind --ncbi --show-reachable=no $(TEST_BINDIR)/test-dependencies

#-------------------------------------------------------------------------------
# test-wvdb
#
TEST_WVDB_SRC = \
	test-wvdb

TEST_WVDB_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_WVDB_SRC))

$(TEST_BINDIR)/test-wvdb: $(TEST_WVDB_OBJ)
	$(LP) --exe -o $@ $^ $(WRITE_LIBS)

wvdb: test-wvdb
	$(TEST_BINDIR)/test-wvdb

valgrind_wvdb: std
	valgrind --ncbi --show-reachable=no $(TEST_BINDIR)/test-wvdb

#-------------------------------------------------------------------------------
# test-sparse-col
#  We will compile the same test file first in read/write mode, create DB and
#  run tests using libncbi-wvdb library; then compile the same test with -DREAD_ONLY
#  and link it against read-only lincbi-vdb library
TEST_SPARSE_COL_SRC = \
	test-sparse-col

TEST_SPARSE_COL_OBJ_RW = \
	$(addsuffix .$(OBJX),$(TEST_SPARSE_COL_SRC)-rw)

TEST_SPARSE_COL_OBJ_RD = \
	$(addsuffix .$(OBJX),$(TEST_SPARSE_COL_SRC)-rd)

TEST_SPARSE_COL_LIB = \
	-skapp \
	-sktst \

$(TEST_SPARSE_COL_OBJ_RW): $(TEST_SPARSE_COL_SRC).cpp
	$(CP) -o $@ $(OPT) $< $(LOC_INFO) -D__file_ext__=cpp

$(TEST_SPARSE_COL_OBJ_RD): $(TEST_SPARSE_COL_SRC).cpp
	$(CP) -o $@ $(OPT) $< $(LOC_INFO) -D__file_ext__=cpp -DREAD_ONLY

$(TEST_BINDIR)/test-sparse-col-rw: $(TEST_SPARSE_COL_OBJ_RW)
	$(LP) --exe -o $@ $^ $(TEST_SPARSE_COL_LIB) -sncbi-wvdb

$(TEST_BINDIR)/test-sparse-col-rd: $(TEST_SPARSE_COL_OBJ_RD)
	$(LP) --exe -o $@ $^ $(TEST_SPARSE_COL_LIB) -sncbi-vdb

sparse-col: test-sparse-col-rw test-sparse-col-rd
	$(TEST_BINDIR)/test-sparse-col-rw
	$(TEST_BINDIR)/test-sparse-col-rd

valgrind_sparse-col: std
	valgrind --ncbi --show-reachable=no $(TEST_BINDIR)/test-sparse-col-rw
	valgrind --ncbi --show-reachable=no $(TEST_BINDIR)/test-sparse-col-rd

#-------------------------------------------------------------------------------
# test-blob-val
#
TEST_BLOB_VAL_SRC = \
	test-blob-val

TEST_BLOB_VAL_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_BLOB_VAL_SRC))

$(TEST_BINDIR)/test-blob-val: $(TEST_BLOB_VAL_OBJ)
	$(LP) --exe -o $@ $^ $(READ_LIBS)

blob-val: test-blob-val
	$(TEST_BINDIR)/test-blob-val

#-------------------------------------------------------------------------------
# SYS-224064
#
SYS_224064_SRC = \
	SYS-224064

SYS_224064_OBJ = \
	$(addsuffix .$(OBJX),$(SYS_224064_SRC))

SYS_224064_LIB = \
	-sncbi-vdb \

$(TEST_BINDIR)/SYS-224064: $(SYS_224064_OBJ)
	$(LP) --exe -o $@ $^ $(SYS_224064_LIB)

SYS-224064: makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@


#-------------------------------------------------------------------------------
# VDB-3060
#
VDB_3060_SRC = \
	test-VDB-3060

VDB_3060_OBJ = \
	$(addsuffix .$(OBJX),$(VDB_3060_SRC))

$(TEST_BINDIR)/test-VDB-3060: $(VDB_3060_OBJ)
	$(LP) --exe -o $@ $^ $(READ_LIBS)

VDB-3060: test-VDB-3060
	$(TEST_BINDIR)/test-VDB-3060

#-------------------------------------------------------------------------------
# VDB-3061
#
VDB_3061_SRC = \
	test-VDB-3061

VDB_3061_OBJ = \
	$(addsuffix .$(OBJX),$(VDB_3061_SRC))

$(TEST_BINDIR)/test-VDB-3061: $(VDB_3061_OBJ)
	$(LP) --exe -o $@ $^ $(READ_LIBS)

VDB-3061: test-VDB-3061
	$(TEST_BINDIR)/test-VDB-3061

#-------------------------------------------------------------------------------
# byte code
#
VDB_BYTECODE_SRC = \
	test-bytecode

VDB_BYTECODE_OBJ = \
	$(addsuffix .$(OBJX),$(VDB_BYTECODE_SRC))

VDB_BYTECODE_LIB = \
	-skapp \
	-sktst \
	-sncbi-wvdb

$(TEST_BINDIR)/test-bytecode: $(VDB_BYTECODE_OBJ)
	$(LP) --exe -o $@ $^ $(VDB_BYTECODE_LIB)

bytecode: test-bytecode
	$(TEST_BINDIR)/test-bytecode

#-------------------------------------------------------------------------------
# v2 View
#
VDB_VIEW_SRC = \
	test-view

VDB_VIEW_OBJ = \
	$(addsuffix .$(OBJX),$(VDB_VIEW_SRC))

VDB_VIEW_LIB = \
	-skapp \
	-sktst \
	-sncbi-wvdb \
	-sschema

$(TEST_BINDIR)/test-view: $(VDB_VIEW_OBJ)
	$(LP) --exe -o $@ $^ $(VDB_VIEW_LIB)

view: test-view
	$(TEST_BINDIR)/test-view

#-------------------------------------------------------------------------------
# test-tablecursor
#
TEST_TABLECURSOR_SRC = \
	test-tablecursor

TEST_TABLECURSOR_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_TABLECURSOR_SRC))

$(TEST_BINDIR)/test-tablecursor: $(TEST_TABLECURSOR_OBJ)
	$(LP) --exe -o $@ $^ $(READ_LIBS)

tcur: test-tablecursor
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-wtablecursor
#
TEST_WTABLECURSOR_SRC = \
	test-wtablecursor

TEST_WTABLECURSOR_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_WTABLECURSOR_SRC))

$(TEST_BINDIR)/test-wtablecursor: $(TEST_WTABLECURSOR_OBJ)
	$(LP) --exe -o $@ $^ $(WRITE_LIBS)

twcur: test-wtablecursor
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-view-cursor
#
TEST_VIEW_CURSOR_SRC = \
	test-view-cursor

TEST_VIEW_CURSOR_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_VIEW_CURSOR_SRC))

$(TEST_BINDIR)/test-view-cursor: $(TEST_VIEW_CURSOR_OBJ)
	$(LP) --exe -o $@ $^ $(VDB_VIEW_LIB) -ssraxf

vcur: test-view-cursor
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# VDB-3305
#
VDB_3305_SRC = \
	test-VDB-3305

VDB_3305_OBJ = \
	$(addsuffix .$(OBJX),$(VDB_3305_SRC))

$(TEST_BINDIR)/test-VDB-3305: $(VDB_3305_OBJ)
	$(LP) --exe -o $@ $^ $(READ_LIBS)

VDB-3305: test-VDB-3305
	$(TEST_BINDIR)/test-VDB-3305


#-------------------------------------------------------------------------------
# VDB-3418
#
VDB_3418_SRC = \
	test-VDB-3418

VDB_3418_OBJ = \
	$(addsuffix .$(OBJX),$(VDB_3418_SRC))

$(TEST_BINDIR)/test-VDB-3418: $(VDB_3418_OBJ)
	$(LP) --exe -o $@ $^ $(READ_LIBS)

VDB-3418: test-VDB-3418
	$(TEST_BINDIR)/test-VDB-3418

#-------------------------------------------------------------------------------
# VDB-4156
#
TEST_VDB4156_SRC = \
	test-VDB-4156

TEST_VDB4156_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_VDB4156_SRC))

$(TEST_BINDIR)/test-VDB-4156: $(TEST_VDB4156_OBJ)
	$(LP) --exe -o $@ $^ $(WRITE_LIBS)

VDB-4156: test-VDB-4156
	$(TEST_BINDIR)/test-VDB-4156

=== debian/changelog ===
ncbi-vdb (2.10.9+dfsg-2) unstable; urgency=medium

  * d/p/fix_2.10.9_refseq_race.patch: Fix a new race in asynchronous
    RefSeq loading code, per upstream (https://github.com/ncbi/ncbi-vdb) 
    commits 06152a5, cf92dca, and b342af2.

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 18 Jan 2021 16:57:54 -0500

ncbi-vdb (2.10.9+dfsg-1) unstable; urgency=medium

  * New upstream version
  * d/watch: Use filemangle to make sure the archive will not mixed up
    with other ncbi code with same version
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 18 Jan 2021 08:27:11 +0100

=== debian/control ===
Source: ncbi-vdb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>, Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs (>= 0.82),
               libbz2-dev,
               libxml2-dev,
               libhdf5-dev,
               libmagic-dev,
               libngs-sdk-dev,
               libngs-java,
               libmbedtls-dev,
               zlib1g-dev,
               default-jdk-headless
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/ncbi-vdb
Vcs-Git: https://salsa.debian.org/med-team/ncbi-vdb.git
Homepage: https://github.com/ncbi/ncbi-vdb
Rules-Requires-Root: no

Package: libncbi-vdb2
Architecture: amd64 i386 x32
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: libraries for using data in the INSDC Sequence Read Archives
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libncbi-vdb-dev
Architecture: amd64 i386 x32
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-vdb2 (= ${binary:Version}),
         libkdf5-dev (= ${binary:Version}),
         libncbi-wvdb-dev (= ${binary:Version}),
         libaec-dev,
         libbz2-dev,
         zlib1g-dev
Description: libraries for using data in the INSDC Sequence Read Archives (devel)
 Much of the data submitted these days, for example in BAM, Illumina
 export.txt, and Complete Genomics formats, contain alignment
 information. With aligned data, NCBI uses Compression by Reference,
 which only stores the differences in base pairs between sequence data
 and the segment it aligns to. The process to restore original data, for
 example as FastQ, requires fast access to the reference sequences that
 the original data was aligned to. NCBI recommends that SRA users
 dedicate local disk space to store references downloaded from the NCBI
 SRA site. As of Fall 2014, the complete collection of these reference
 sequences is 66 GB. While it isn't usually necessary to download the
 entirety of the reference sequences, this should give you an idea of the
 scale of the storage requirement. By default, the Toolkit will download
 missing reference sequences on demand and cache them in the user's home
 directory. The location of this cache is configurable, as is whether the
 download is automatic or manual.
 .
 This is the development package.

Package: libkdf5-2
Architecture: amd64 i386 x32
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libmbedtls-dev
Description: hdf5 access to data in the INSDC Sequence Read Archives
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides an interface
 to the Hierarchical Data Format 5 (HDF5).

Package: libkdf5-dev
Architecture: amd64 i386 x32
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libkdf5-2 (= ${binary:Version})
Description: hdf5 access to data in the INSDC Sequence Read Archives (devel)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides an interface
 to the Hierarchical Data Format 5 (HDF5).
 .
 This is the development package.

Package: libncbi-wvdb2
Architecture: amd64 i386 x32
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: virtual layer update modul of ncbi-vdb library
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package.

Package: libncbi-wvdb-dev
Architecture: amd64 i386 x32
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-wvdb2 (= ${binary:Version})
Description: virtual layer update modul of ncbi-vdb library (devel)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package.
 .
 This is the development package.

Package: libvdb-sqlite2
Architecture: amd64 i386 x32
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: sqlite modul of ncbi-vdb library
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides a sqlite
 interface.

Package: libvdb-sqlite-dev
Architecture: amd64 i386 x32
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libvdb-sqlite2 (= ${binary:Version})
Description: sqlite modul of ncbi-vdb library (devel)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides a sqlite
 interface.
 .
 This is the development package.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DH_BUILD_MAINT_OPTIONS := nocheck

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
CPU := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# since build-results are not ending up in the proper dir its saver to use "*" instead of "$(CPU)"
SODIR := $(DEB_SOURCE)/$(DEB_SOURCE)/$(OS)/gcc
VDB_ARCH := $(word 1, $(subst -, ,$(DEB_HOST_MULTIARCH)))
LIBINSTALLDIR := debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/$(VDB_ARCH)/dbg/lib
LIBPKG := libncbi-vdb2
SCHEMADIR := debian/$(LIBPKG)/usr/lib/$(DEB_SOURCE)
DSLMFLAGS := --commit --multiarch --devunversioned --exclude-la \
             --override s/libmbedx509-0-dev/libmbedtls-dev/

# See debian/patches/fix-linking
# export DEB_LDFLAGS_MAINT_APPEND := -Wl,-z,defs -Wl,--as-needed
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@

override_dh_auto_clean:
	if [ -e ngs-sdk/Makefile.config.$(OS).$(CPU) ] ; then \
		dh_auto_clean ; \
	fi
	rm -rf $(DEB_SOURCE)/$(MULTIARCH)
	rm -f libs/ngs-jni/jni.h
	rm -f libs/ngs-jni/jni_md.h
	rm -f build/ld.linux.exe_cmd.sh

override_dh_auto_configure:
	# that's no standard configure script lacking support of default options
	# The build system shamelessly ignores those options like
	#    --with-ngs-java-prefix=/usr/share/java
	# so we need to go with patches.  The options are specified anyway.
	ln -s /usr/lib/jvm/default-java/include/jni.h		libs/ngs-jni
	ln -s /usr/lib/jvm/default-java/include/linux/jni_md.h	libs/ngs-jni
	./configure --build=$(MULTIARCH) --prefix=/usr --build-prefix=$(CURDIR)/debian/tmp/usr --with-ngs-sdk-prefix=/usr --with-debug --with-ngs-java-prefix=/usr/share/java
	# no idea how to convince configure script to use the correct include dir so patching result afterwards
	sed -i 's?HDF5_INCDIR = /usr/include?&/hdf5/serial?' build/Makefile.config*

override_dh_auto_build:
	dh_auto_build --no-parallel
	# we need to make really sure that no 'vdb_'-prefixed functions will remain ...
	if find . \( -name "*.so" -o -name "*.a" \) -exec strings \{\} \; | tee | grep -q vdb_mbedtls ; then \
	    find . \( -name "*.so" -o -name "*.a" \) -exec strings \{\} \; | tee | grep vdb_mbedtls ; \
	    grep -Rl vdb_mbedtls  debian/tmp/* ; \
	    exit 1 ; \
	    false ; \
	fi

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# FIXME: some tests keep on failing despite debian/patches/skip_failing_test.patch - needs to be sorted out later
	dh_auto_test || true
else
	echo "Skip testing which takes a long time"
endif

override_dh_prep:
	dh_prep -Xdebian/tmp

override_dh_auto_install:
	dh_auto_install
	find $(LIBINSTALLDIR) -name "*-static.a" -delete
	# upstream installs versioned *.a libs - we only want a single version
	for slib in $(LIBINSTALLDIR)/*.a ; do \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	done
	d-shlibmove $(DSLMFLAGS) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-ngs-c++.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkapp.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkapp-norsrc.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkff.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libktst.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkxfs.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkxml.a usr/lib/$(MULTIARCH) \
                    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libload.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libtui.a usr/lib/$(MULTIARCH) \
                    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libtui_cpp.a usr/lib/$(MULTIARCH) \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-vdb.so
	install -d debian/libncbi-vdb-dev/usr/include
	cp -a interfaces debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE)
	# json-response.h and services-priv.h are needed by sra-sdk, but
	# the latter shouldn't replace interfaces/vfs/services-priv.h.
	dh_install -plibncbi-vdb-dev libs/vfs/json-response.h usr/include/ncbi-vdb/vfs
	cp libs/vfs/services-priv.h debian/libncbi-vdb-dev/usr/include/ncbi-vdb/vfs/services-priv-internal.h
	d-shlibmove $(DSLMFLAGS) \
		    --override s/libhdf5_serial[0-9]*-dev/libhdf5-dev/ \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libkdf5.so
	d-shlibmove $(DSLMFLAGS) \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-wvdb.so
	d-shlibmove $(DSLMFLAGS) \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libvdb-sqlite.so
	find debian/lib* -name .gitignore -delete
	# move schemata from development packages to library packages since these are used in executables
	mkdir -p $(SCHEMADIR)
	set -x ; \
	for schema in `find debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE) -name "*.vschema"` ; do \
	    schemafile=`basename $${schema}` ; \
	    schemadir=`basename $$(dirname $${schema})` ; \
	    mkdir -p $(SCHEMADIR)/$${schemadir} ; \
	    sed -i "s:^include ':&/usr/lib/ncbi-vdb/:" $${schema} ; \
	    mv $${schema} $(SCHEMADIR)/$${schemadir} ; \
	done

override_dh_missing:
	dh_missing --fail-missing
